#pragma once

class CImage
{
public:
	CImage();
    ~CImage();
    
	void Create(int cols, int rows, int channels);
	void CreateRandom(int cols, int rows, int channels);
	void CreateTestImage(int cols, int rows, int channels);
	void CheckTestImage(int origWidth, int origHeight, float xScale, float yScale);
    bool Read(const char* pFilename);
	bool Write(const char* pFilename);
	CImage* Resize(float xScale, float yScale, int inerpolation, int numThreads, int intelVersion, int* elapseTime);
	CImage* ResizeMod(float xScale, float yScale, int inerpolation, int numThreads, int vChunks, int hChunks, int intelVersion, int* elapseTime);
    int Rows();
    int Cols();
	size_t Stride();
	size_t Size();
	int Channels();
	unsigned char* pData();

private:
	//Resize(float xScale, float yScale, int inerpolation, RECT);

private:
    unsigned char*       m_pData;
	int			m_width;
	int			m_height;
	int			m_channels;
};